<?php

namespace MABEL_WOF\Code\Services {

	use MABEL_WOF\Core\Common\Managers\Settings_Manager;

	class CC_Service {

		public static function form_html($wheel_id, $fb_obligated,$allow_duplicates){

			$random_val = time(); 
			$config = self::get_config();
			?>

			<div class="wof-fb-checkbox" style="background: white; display: block; border-radius: 4px;">
				<div class="fb-messenger-checkbox"
					origin="<?php echo esc_url(home_url( '/' )); ?>"
					page_id="<?php echo $config['page_id']; ?>"
					messenger_app_id="<?php echo $config['app_id']; ?>"
					user_ref="<?php echo $random_val; ?>"
					ref="<?php echo $wheel_id ?>"
					prechecked="false"
					allow_login="true"
					size="large">
				</div>
			</div>
			<script>
				(function(d, s, id){
					var js, fjs = d.getElementsByTagName(s)[0];
					if (d.getElementById(id)) {return;}
					js = d.createElement(s); js.id = id;
					js.src = "https://connect.facebook.net/en_US/sdk.js";
					fjs.parentNode.insertBefore(js, fjs);
				}(document, 'script', 'facebook-jssdk'));

				if(!window.fbAsyncInit)
					window.fbAsyncInit = function() {
						FB.init({
							appId      : <?php echo $config['app_id'] ?>,
							xfbml      : true,
							cookie     : true,
							version    : 'v2.11'
						});

						FB.Event.subscribe('messenger_checkbox', function(e) {

							if(e.event === 'checkbox') {
								WOF.Dispatcher.publish('wof-fb-checkbox-'+e.state,{
									wheel:e.ref
								});
							}

						});
					};

				jQuery(document).ready(function() {

					var wofFbConfig = {
						wheelId:            <?php echo $wheel_id; ?>,
						isObligated:        <?php echo $fb_obligated ? 'true' : 'false'; ?>,
						allowDuplicates:    <?php echo $allow_duplicates ? 'true' : 'false'; ?>,
						isChecked:          false
					};

					WOF.Dispatcher.subscribe('wof-fb-checkbox-checked',function(data) {
						if(data.wheel == wofFbConfig.wheelId )
							wofFbConfig.isChecked = true;
					});

					WOF.Dispatcher.subscribe('wof-fb-checkbox-unchecked',function(data) {
						if(data.wheel == wofFbConfig.wheelId )
							wofFbConfig.isChecked = false;
					});

					WOF.Dispatcher.addFilter('wof-can-optin',function(wheel) {

						if(wheel.id == wofFbConfig.wheelId) {
							if(!wofFbConfig.isObligated)
								return true;

							if(!wofFbConfig.isChecked)
								wheel.element.find('.wof-fb-checkbox').addClass('wof-form-error do-form-nudge');

							return wofFbConfig.isChecked;
						}

						return true;
					});

					if(!wofFbConfig.allowDuplicates) {
						WOF.Dispatcher.addFilter('wof-optin-request-data',function(data) {
							if(data.id === wofFbConfig.wheelId)
								data.cc_session_id = window.chatchamp.sessionId;
							return data;
						});
					}

					WOF.Dispatcher.subscribe('wof-submit-clicked',function(wheel) {
						if(wheel.id == wofFbConfig.wheelId && wofFbConfig.isChecked){
							window.FB.AppEvents.logEvent('MessengerCheckboxUserConfirmation', null, {
								'app_id':'<?php echo $config['app_id']; ?>',
								'page_id':'<?php echo $config['page_id']; ?>',
								'user_ref':'<?php echo $random_val; ?>',
								'ref':JSON.stringify({
									chatchampSessionId: window.chatchamp.sessionId,
									source: 'wp-optin-wheel'
								})
							});
						}
					});

				});
			</script>
			<?php
		}

		public static function get_config() {

			$id = Settings_Manager::get_setting('cc_id');

			$response = self::request('config/'.$id);

			if($response === null || $response->status !== 200)
				return array();

			return array(
				'app_id' => $response->body->facebookAppId,
				'page_id' => $response->body->facebookPageId
			);

		}

		public static function is_in_list($user_id) {
			if(empty($user_id))
				return true;

			$subscriber = self::get_subscriber($user_id);
			if($subscriber === null || $subscriber['subscription_state'] !== 'subscriber')
				return false;
			return true;
		}

		private static function get_subscriber($session_id) {
			$response = self::request('subscribers/'.$session_id);
			if($response === null || $response->status !== 200)
				return null;

			return array(
				'first_name' => $response->body->subscriber->firstName,
				'last_name' => $response->body->subscriber->lastName,
				'subscription_state' => $response->body->subscriber->subscriptionState
			);
		}

		private static function request( $action, array $body = null, $method = 'get' ) {
			$url = 'https://api.chatchamp.io/' . $action;

			$headers = array(
				'Content-Type' => 'application/json'
			);

			$options = array(
				'timeout' => 15,
				'headers' => $headers
			);

			if ( $body != null && $method === 'post' ) {
				$options['body'] = $body;
			}

			$response = $method === 'post' ? wp_remote_post( $url, $options ) : wp_remote_get( $url, $options );

			if ( is_wp_error( $response ) ) {
				return null;
			}

			return (object) array(
				'status' => $response['response']['code'],
				'body'   => json_decode( wp_remote_retrieve_body( $response ) )
			);
		}
	}
}
